/*
Demo Script for Resource Governor
www.sql-articles.com
www.chnsqlug.com
Vidhya Sagar / 31 Oct CSSUG meet
*/
--Creating Classifier function on login
USE master
GO
CREATE FUNCTION [dbo].[fn_resourcegovernor]() 
RETURNS sysname 
WITH SCHEMABINDING
AS
	BEGIN
	DECLARE @grp_name sysname
	IF (SUSER_NAME() = 'lowpriorityuser')
		SET @grp_name = 'lowendgroup'
	ELSE IF (SUSER_NAME() ='highpriorityuser')
		SET @grp_name = 'highendgroup'
	RETURN @grp_name
END;


--Creating High end resource Pool
CREATE RESOURCE POOL [highendpool] WITH(min_cpu_percent=80, 
		max_cpu_percent=100, 
		min_memory_percent=0, 
		max_memory_percent=100)
GO
--Creating High end workload group and associating with high end resource pool
/****** Object:  WorkloadGroup [highendgroup]    Script Date: 10/29/2009 18:30:25 ******/
CREATE WORKLOAD GROUP [highendgroup] WITH(group_max_requests=0, 
		importance=High, 
		request_max_cpu_time_sec=0, 
		request_max_memory_grant_percent=25, 
		request_memory_grant_timeout_sec=0, 
		max_dop=0) USING [highendpool]
GO


--Creating Low end resource Pool
/****** Object:  ResourcePool [lowendpool]    Script Date: 10/29/2009 18:30:40 ******/
CREATE RESOURCE POOL [lowendpool] WITH(min_cpu_percent=0, 
		max_cpu_percent=50, 
		min_memory_percent=0, 
		max_memory_percent=50)

GO

--Creating Low end workload group and associating with low end resource pool
/****** Object:  WorkloadGroup [lowendgroup]    Script Date: 10/29/2009 18:30:51 ******/
CREATE WORKLOAD GROUP [lowendgroup] WITH(group_max_requests=0, 
		importance=Medium, 
		request_max_cpu_time_sec=0, 
		request_max_memory_grant_percent=25, 
		request_memory_grant_timeout_sec=0, 
		max_dop=1) USING [lowendpool]
GO


--Assigining Classifier function to resource governor
ALTER RESOURCE GOVERNOR WITH (CLASSIFIER_FUNCTION = [dbo].[fn_resourcegovernor]);
GO

--Reconfiguring resource governor to make it effective
ALTER RESOURCE GOVERNOR RECONFIGURE;
GO

--Verify
SELECT a.session_id,a.login_name, b.name [Workload GroupName]FROM sys.dm_exec_sessions a JOIN
sys.dm_resource_governor_workload_groups b ON a.group_id=b.group_id WHERE a.session_id>50